; ---USAGE---

; `python3 ok -q QUESTION`

; e.g. `python3 ok -q replicate`


;;; Discussion 11 - Interpreters ;;;


; Q6 - replicate
;;; Tests
; (replicate 5 3)
; expect (5 5 5)

(define (replicate x n)
  (if (= n 0)
    nil
    (cons x (replicate x (- n 1)))
  )
)


(define (my-append a b)
  (if (null? a)
    b
    (cons (car a) (my-append (cdr a) b))
  )
)

; Q7 - uncompress
;;; Tests
; (uncompress '((a 1) (b 2) (c 3)))
; expect (a b b c c c)

(define (uncompress s)
  (if (null? s)
    s
    (my-append (replicate (car (car s)) (car (cdr (car s))))
      (uncompress (cdr s)))
  )
)


; Q8 - map
;;; Tests
; (map (lambda (x) (* x x)) '(1 2 3))
; expect (1 4 9)

(define (map fn lst)
  (if (null? lst)
    nil
    (cons (fn (car lst)) (map fn (cdr lst)))
  )
)


(define (make-tree label branches) (cons label branches))

(define (label tree)
  (car tree)
)

(define (branches tree)
  (cdr tree)
)

; Q10 - tree-sum
;;; Tests
; (define t (make-tree 1 (list (make-tree 2 nil) (make-tree 3 nil))))
; expect t
; (tree-sum t)
; expect 6

(define (tree-sum tree)
  (+ (label tree) (sum (map tree-sum (branches tree))))
)

(define (sum lst)
  (if (null? lst)
    0
    (+ (car lst) (sum (cdr lst)))
  )
)
